#include <string.h>
#include <malloc.h>

#include "../include/events/ae_events.h"
#include "../xmem/src/include/xmem.h"

void e_f_create(char *event_id) {
	struct e_listItem_struct *item;

	item = XMALLOC(struct e_listItem_struct, 1);
	
	item->event_id = event_id;
	item->fHandler = NULL;
	item->lHandler = NULL;

	if(e.rawList->first == NULL) {
		e.rawList->first = item;
		e.rawList->last = item;

		item->prev = item;
		item->next = item;
	} else {
		e.rawList->last->next = item;

		item->prev = e.rawList->last;
		item->next = e.rawList->first;

		e.rawList->first->prev = item;
		e.rawList->last = item;
	}
}

struct e_listItem_struct *e_f_find(char *event_id) {
	struct e_listItem_struct *begin, *current;
	int found = 0;

	begin = e.rawList->first;
	current = begin;

	while(1) {
		if(strcmp(current->event_id, event_id) == 0) {
			found = 1;
			return current;
		} else {
			current = current->next;

			if(current == begin) {
				break;
			}
		}
	}

	if(found == 1) {
		return current;
	} else {
		return NULL;
	}
}

void e_f_invoke(char *event_id) {
	struct e_listItem_struct *e;
	struct e_handlerItem_struct *h, *b;

	e = e_f_find(event_id);

	if(e != NULL) {
		b = e->fHandler;
		h = e->fHandler;

		while(1) {
			h->handler();
			h = h->next;

			if(h == b) {
				break;
			}
		}
	}
}

void e_f_addHandler(char *event_id, void *f) {
	struct e_listItem_struct *e;
	struct e_handlerItem_struct *h;

	e = e_f_find(event_id);

	if(e != NULL) {
		h = XMALLOC(struct e_handlerItem_struct, 1);
		h->handler = f;

		if(e->fHandler == NULL) {
			e->fHandler = h;
			e->lHandler = h;
		} else {
			e->lHandler->next = h;
			h->prev = e->lHandler;
			e->fHandler->prev = h;
			h->next = e->fHandler;
			e->lHandler = h;
		}
	}
}

void e_bs(void)  {
	e.create = &e_f_create;
	e.invoke = &e_f_invoke;
	e.addHandler = &e_f_addHandler;
	e.rawList = &e_list;
}