#include <pthread.h>
#include <unistd.h>

#define wf_clientRelease(c) (c)->stage++
#define wf_resetConnection(s) close(s)

#include "../mario/src/include/mario.h"

struct wf_statuses_s {
	int code;
	char *status;
	int length;
};

struct wf_protocols_s {
	double version;
	char *protocol;
};

struct wf_methods_s {
	char *method;
};

struct wf_headers_s {
	char *header;
};

struct webFactory_s {
	struct webFactoryConfig_s *config;
	unsigned shutdown : 1;
	int totalWorkers;
	int workersCount;
	struct wf_worker_s *firstWorker;
	struct wf_worker_s *lastWorker;
} wf;

/** New code **/

struct wf_worker_waitClient {
	int socket;
	struct wf_worker_waitClient *next;	
};

struct wf_waitClientList {
	unsigned int total;
	struct wf_worker_waitClient *first;
	struct wf_worker_waitClient *last;
};

struct wf_client_s {
	int socket;
	int target;
	int maxTicks;
	size_t targetSize;
	size_t bytesGiven;
	unsigned int bbtick;
	unsigned int bsize;
	unsigned int bused;
	unsigned int stage;
	unsigned targetFound : 1;
	char *rawHttpQuery;
	char *httpResponse;
	struct mario_parsed_s *parsedHttpQuery;
	struct wf_worker_s *workerOwner;
	struct wf_client_s *prev;
	struct wf_client_s *next;
};

struct wf_worker_s {
	int id;
	unsigned up : 1;
	pthread_t thread;
	int totalClients;
	struct wf_client_s *fClient;
	struct wf_client_s *lClient;
	struct wf_client_s *cClient;
	struct wf_worker_s *prev;
	struct wf_worker_s *next;
	struct wf_waitClientList *waitClients;
	pthread_mutex_t clientsList_op;
};

struct wf_client_s *wf_workerClientDeclare(struct wf_worker_s *worker, int socket);
void wf_workerClientRemove(struct wf_worker_s *worker, struct wf_client_s *client);
void wf_readClientQuery(struct wf_client_s *client);
void wf_handleClientQuery(struct wf_client_s *client);
struct wf_client_s *wf_selectClient(struct wf_worker_s *worker);
void wf_workerRespondClient(struct wf_client_s *client);
void wf_workerPumpoverData(struct wf_client_s *client);
void *wf_workerThread(void *fparam);
void wf_throwClient(int socket);
void wf_workerHotCreate(void);
void wf_bootstrap(void);